/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_CM_MAKER_FROM_FFT_WITH_FLAG_H_INCLUDED_)
#define _HARKLIB_NODE_CM_MAKER_FROM_FFT_WITH_FLAG_H_INCLUDED_ 1

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"
#include "hark-lib/matrix.h"

namespace hark
{
namespace node
{
    class CMMakerFromFFTwithFlag: public NodeDef
    {
    public:
        CMMakerFromFFTwithFlag();

        void initialize(InputDataBundle &input);
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        std::string duration_type;
        std::string window_type;
        int nb_channels;
        int pslength;
        int period;
        int window;
        int look_ahead;
        int look_back;
        int max_sum_count;
        int sum_count;
        int sum_count_accum;
        int adder_period;
        bool adder_flag;
        bool normalize_flag;
        bool enable_accum;
        bool enable_debug;
        Matrix<std::complex<float> > x;
        std::deque<Matrix<std::complex<float> > > xbuf;
        std::vector<Matrix<std::complex<float> > > Rxx;
        std::vector<Matrix<std::complex<float> > > RxxT;
    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_CM_MAKER_FROM_FFT_WITH_FLAG_H_INCLUDED_) */

/* end of file */
