/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_CM_MULTIPLY_MATRIX_H_INCLUDED_)
#define _HARKLIB_NODE_CM_MULTIPLY_MATRIX_H_INCLUDED_ 1

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"
#include "hark-lib/matrix.h"

namespace hark
{
namespace node
{
    class CMMultiplyMatrix: public NodeDef
    {
    public:
        CMMultiplyMatrix();

        void initialize(InputDataBundle &input);
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        int nb_channels;
        int pslength;
        bool first_frame_execution;
        bool enable_debug;
        Matrix<std::complex<float> > Rxx;
    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_CM_MULTIPLY_MATRIX_H_INCLUDED_) */

/* end of file */
