/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_SOURCE_INTERVAL_EXTENDER_H_INCLUDED_)
#define _HARKLIB_NODE_SOURCE_INTERVAL_EXTENDER_H_INCLUDED_ 1

#include <vector>
#include <climits>

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"

#include "hark-lib/source.h"

namespace hark
{
namespace node
{
    class SourceIntervalExtender: public NodeDef
    {
    public:
        SourceIntervalExtender();

        void initialize(InputDataBundle &input);
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        data find_source(std::vector<data> &sources, int &id);

        int preroll_length;
        std::map<int, int> remaining_time;
        data prev_out;
    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_SOURCE_INTERVAL_EXTENDER_H_INCLUDED_) */

/* end of file */
